<?

/*

PHeadlines Class 0.1 (Nov 4, 1999)
a news headline grabbing engine which caches the links in a MySQL database
http://www.dansteinman.com/pheadlines/

Copyright (C) 1999 Dan Steinman (dan@dansteinman.com)

This is free software under the terms of the GNU General Public License

*/

class PHeadlines {

	// enter your MySQL information
	// note: it's recommended that you set these from your own script
	// so that you don't have to edit this class
	var $mysql_host = "";
	var $mysql_username = "";
	var $mysql_password = "";
	var $mysql_db = "";
	
	// how many minutes to cache the links for
	var $cache_minutes = 60;

	// number of links to display
	var $link_limit = 10;
	
	// socket timeout in seconds
	var $socket_timeout = 20;

	// List of sites
	var $sites = array(	
		"slashdot" => array("Slashdot","http://slashdot.org","/slashdot.rdf","rdf"),
		"freshmeat" => array("Freshmeat","http://freshmeat.net","/backend/fm.rdf","fm"),
		"linuxtoday" => array("Linux&nbsp;Today","http://linuxtoday.com","/backend/linuxtoday.xml","lt"),
		"gametome" => array("Linux&nbsp;Game&nbsp;Tome","http://happypenguin.org","/html/news.rdf","rdf"),
		"segfault" => array("Segfault","http://segfault.org","/stories.xml","sf"),
		"kdenews" => array("KDE&nbsp;News","http://www.kde.org","/news/kdenews.rdf","rdf"),
		"gnomenews" => array("Gnome&nbsp;News","http://news.gnome.org","/gnome-news/rdf","rdf"),
		"gimpnews" => array("Gimp&nbsp;News","http://www.xach.com/gimp/news/","channel.rdf","rdf-chan"),
		"mozilla" => array("Mozilla","http://www.mozilla.org","/news.rdf","rdf-chan"),
		"mozillazine" => array("MozillaZine","http://www.mozillazine.org","/contents.rdf","rdf")
	);

	// wired news was messing up, I dunno
	// "wired" => array("Wired&nbsp;News","http://www.wired.com","/news_drop/netcenter/netcenter.rdf/","rdf"),	

	// try to get the links for the site
	function getLinks($which) {
		if (!$this->sites[$which]) { // if no such site
			return false;
		}
		else if ($this->isCached($which)) {
			$links = $this->getLinksDB($which);  // get from db
		}
		else {  // cache has expired
			$links = $this->getLinksSite($which);  // get from site

			if ($links) { // successful
				$this->saveToDB($which,$links);  // cache
			}
			else {  // timed out
				$links = $this->getLinksDB($which);  // try from db
				$this->error_timeout = true;
			}
		}
		return $links;
	}

	// determines if the headlines were cached less than $cache_mintues minutes ago
	function isCached($which) {
		$this->mysql_linkID = mysql_connect($this->mysql_host,$this->mysql_username,$this->mysql_password) or die("Unable to connect to database");
		mysql_select_db($this->mysql_db,$this->mysql_linkID) or $this->createDB();  // create the db if it doesn't exist

		if ($result = mysql_query("select time from cache_times where(site='$which')",$this->mysql_linkID)) {
		$row = mysql_fetch_array($result);
		$cached_time = $row[0];
		$this->current_time = time();
		
		return (($this->current_time-$cached_time)<$this->cache_minutes*60);
		}
		else {
			mysql_query("create table cache_times (site VARCHAR(16), time INT UNSIGNED)",$this->mysql_linkID);
			return 0;
		}
	}

	// get the links from the database
	function getLinksDB($which) {
		$result = mysql_query("select * from $which",$this->mysql_linkID);

		if (!$result || mysql_num_rows($result)==0) {  // if none in db
			$links = $this->getLinksSite($which);  // try from site again
			if (!$links) {
				$url = $this->sites[$which][1].$this->sites[$which][2];
				die("<b>error</b>: unable to get links for $which<br><a href=\"$url\">$url</a>");
			}
		}
		
		while($row = mysql_fetch_array($result)) {
			$links[$row['title']] = $row['link'];
		}
		return $links;
	}

	// get a new set of links from the site
	function getLinksSite($which) {
		// determine the options to properly extract the links
		$type = $this->sites[$which][3];
		$startat = "</image>";  // line to start at
		$linkstr = "link";  // the xml tag around the url
		$exclude = "";  // the title of a link to ignore
		
		if ($type=="rdf-chan") $startat = "</channel>";
		else if ($type=="lt") $linkstr = "url";
		else if ($type=="fm") $exclude = "quick finder";
		else if ($type=="sf") $startat = "</textinput>";
		
		// get the file that contains the links
		$lines = $this->getSocketFile($this->sites[$which][1].$this->sites[$which][2]);
		if (!$lines) return false;
	
		// determine which line to begin grabbing the links
		for ($i=0;$i<count($lines);$i++) {
			if (ereg($startat,$lines[$i],$regs)) {
				$startnum = $i;
				break;
			}
		}

		// extract the links and assemble into array $links
		$links = array();
		for ($i=$startnum;$i<count($lines);$i++) {
			if (count($links)>=$this->link_limit) break;
			if (ereg("<title>(.*)</title>",$lines[$i],$regs)) {
				if ($regs[1] == $exclude) {$i+=1; break;}
				$title = $regs[1];
				$title = ereg_replace("&amp;apos;","'",$title);
			}
			else if (ereg("<$linkstr>(.*)</$linkstr>",$lines[$i],$regs)) {
				$links[$title] = $regs[1];
			}
		}
		
		return $links;
	}

	// return contents of a web url as an array or false if timeout
	function getSocketFile($url) {
		$server = ereg_replace("http://","",$url);
		$file = strstr($server,"/");
		$server = ereg_replace("$file","",$server);
		$fp = fsockopen($server, 80, &$errno, &$errstr);
		if ($fp) {
			fputs($fp,"GET $file HTTP/1.0\nHost: $server\n\n");
			while ($line = fgets($fp, 4096)) {
				$lines[] = $line;
			}
			fclose($fp);
			return $lines;
		}
		else {
			return false;
		}
	}
	
	// get a list of the sites
	function getList() {
		while(list($name,$value) = each($this->sites)) {
			$links[$value[0]] = $name;
		}
		return $links;
	}

	// save the new set of links and update the cache time
	function saveToDB($which,$links) {
		$result = mysql_query("delete from $which",$this->mysql_linkID);
		if (!$result) mysql_query("create table $which (title VARCHAR(255), link VARCHAR(255))",$this->mysql_linkID);
		
		// save links
		while (list($title,$link) = each($links)) {
			mysql_query("insert into $which VALUES(\"$title\",\"$link\")",$this->mysql_linkID);
		}		
		
		// save cache time
		mysql_query("delete from cache_times where(site='$which')",$this->mysql_linkID);
		mysql_query("insert into cache_times VALUES('$which','$this->current_time')",$this->mysql_linkID);
	}
	
	// try to create the db if it doesn't exist
	function createDB() {
		mysql_create_db($this->mysql_db,$this->mysql_linkID);
		mysql_select_db($this->mysql_db,$this->mysql_linkID);
	
		mysql_query("create table cache_times (site VARCHAR(16), time INT UNSIGNED)",$this->mysql_linkID);
		
		while(list($name) = each($this->sites)) {
			mysql_query("create table $name (title VARCHAR(255), link VARCHAR(255))",$this->mysql_linkID);
			mysql_query("insert into cache_times VALUES(\"$name\",0)",$this->mysql_linkID);
		}
		
		die("Successfully created database \"$this->mysql_db\"<p>Please reload.");
	}
}

?>
